;;; can

.if __DEVICE__ = __at90can128__

;; defines

.equ CANGCON = $d8
  .equ ABRQ = 7
  .equ OVRQ = 6
  .equ TTC = 5
  .equ SYNTTC = 4
  .equ LISTEN = 3
  .equ TEST = 2
  .equ ENASTB = 1
  .equ SWRES = 0
.equ CANGSTA = $d9
  .equ OVRG = 6
  .equ TXBSY = 4
  .equ RXBSY = 3
  .equ ENFG = 2
  .equ BOFF = 1
  .equ ERRP = 0
.equ CANGIT = $da
  .equ CANIT = 7
  .equ BOFFIT = 6
  .equ OVRTIM = 5
  .equ BXOK = 4
  .equ SERG = 3
  .equ CERG = 2
  .equ FERG = 1
  .equ AERG = 0
.equ CANGIE = $db
  .equ ENIT = 7
  .equ ENBOFF = 6
  .equ ENRX = 5
  .equ ENTX = 4
  .equ ENERR = 3
  .equ ENBX = 2
  .equ ENERG = 1
  .equ ENOVRT = 0
.equ CANEN2 = $dc
.equ CANEN1 = $dd
.equ CANIE2 = $de
.equ CANIE1 = $df
.equ CANSIT2 = $e0
.equ CANSIT1 = $e1
.equ CANBT1 = $e2
  .equ BRP5 = 6
  .equ BRP4 = 5
  .equ BRP3 = 4
  .equ BRP2 = 3
  .equ BRP1 = 2
  .equ BRP0 = 1
.equ CANBT2 = $e3
  .equ SJW1 = 6
  .equ SJW0 = 5
  .equ PRS2 = 3
  .equ PRS1 = 2
  .equ PRS0 = 1
.equ CANBT3 = $e4
  .equ PHS22 = 6
  .equ PHS21 = 5
  .equ PHS20 = 4
  .equ PHS12 = 3
  .equ PHS11 = 2
  .equ PHS10 = 1
  .equ SMP = 0
.equ CANTCON = $e5
.equ CANTIML = $e6
.equ CANTIMH = $e7
.equ CANTTCL = $e8
.equ CANTTCH = $e9
.equ CANTEC = $ea
.equ CANREC = $eb
.equ CANHPMOB = $ec
  .equ HPMOB3 = 7
  .equ HPMOB2 = 6
  .equ HPMOB1 = 5
  .equ HPMOB0 = 4
  .equ CGP3 = 3
  .equ CGP2 = 2
  .equ CGP1 = 1
  .equ CGP0 = 0
.equ CANPAGE = $ed
  .equ MOBNB3 = 7
  .equ MOBNB2 = 6
  .equ MOBNB1 = 5
  .equ MOBNB0 = 4
  .equ AINC = 3
  .equ INDX2 = 2
  .equ INDX1 = 1
  .equ INDX0 = 0
.equ CANSTMOB = $ee
  .equ DLCW = 7
  .equ TXOK = 6
  .equ RXOK = 5
  .equ BERR = 4
  .equ SERR = 3
  .equ CERR = 2
  .equ FERR = 1
  .equ AERR = 0
.equ CANCDMOB = $ef
  .equ CONMOB1 = 7
  .equ CONMOB0 = 6
  .equ RPLV = 5
  .equ IDE = 4
  .equ DLC3 = 3
  .equ DLC2 = 2
  .equ DLC1 = 1
  .equ DLC0 = 0
.equ CANIDT4 = $f0
  .equ RTRTAG = 2
  .equ RB1TAG = 1
  .equ RB0TAG = 0
.equ CANIDT3 = $f1
.equ CANIDT2 = $f2
.equ CANIDT1 = $f3
.equ CANIDM4 = $f4
.equ CANIDM3 = $f5
.equ CANIDM2 = $f6
.equ CANIDM1 = $f7
.equ CANSTML = $f8
.equ CANSTMH = $f9
.equ CANMSG = $fa


;; brp
;;
;; ( n -- )

link_
.db "brp",0

brp:
  subi tosl,1
  lsl tosl
  andi tosl,$7e
  out_ CANBT1,tosl
  drop_
  ret


;; sjw
;;
;; ( n -- )

link_
.db "sjw",0

sjw:
  subi tosl,1
  lsl tosl
  lsl tosl
  lsl tosl
  lsl tosl
  lsl tosl
  andi tosl,$60

  in_ temp0,CANBT2
  andi temp0,$0e
  or temp0,tosl
  out_ CANBT2,temp0

  drop_
  ret


;; prs
;;
;; ( n -- )

link_
.db "prs",0

prs:
  subi tosl,1
  lsl tosl
  andi tosl,$0e

  in_ temp0,CANBT2
  andi temp0,$60
  or temp0,tosl
  out_ CANBT2,temp0

  drop_
  ret


;; phs2
;;
;; ( n -- )

link_
.db "phs2",0,0

phs2:
  subi tosl,1
  lsl tosl
  lsl tosl
  lsl tosl
  lsl tosl
  andi tosl,$70

  in_ temp0,CANBT3
  andi temp0,$0f
  or temp0,tosl
  out_ CANBT3,temp0

  drop_
  ret


;; phs1
;;
;; ( n -- )

link_
.db "phs1",0,0

phs1:
  subi tosl,1
  lsl tosl
  andi tosl,$0e

  in_ temp0,CANBT3
  andi temp0,$71
  or temp0,tosl
  out_ CANBT3,temp0

  drop_
  ret


;; smp
;;
;; ( n -- )

link_
.db "smp",0

smpp:
  andi tosl,$01

  in_ temp0,CANBT3
  andi temp0,$7e
  or temp0,tosl
  out_ CANBT3,temp0

  drop_
  ret


;; can
;;
;; ( -- )

link_
.db "can",0

can:
  ldi temp0,(1<<ENASTB)
  out_ CANGCON,temp0
  ret


;; /can
;;
;; ( -- )

link_
.db "/can",0,0

notcan:
  out_ CANGCON,zero
  ret


;; mob
;;
;; ( n -- )

link_
.db "mob",0

mob:
  andi tosl,$0f
  swap tosl
  out_ CANPAGE,tosl
  drop_
  ret


;; mobclr
;;
;; ( -- )

link_
.db "mobclr",0,0

mobclr:
  ; clear mob control registers
  ldi xl,low(CANSTMOB)
  ldi xh,high(CANSTMOB)
  st x+,zero ; CANSTMOB
  st x+,zero ; CANCDMOB
  st x+,zero ; CANIDT4
  st x+,zero ; CANIDT3
  st x+,zero ; CANIDT2
  st x+,zero ; CANIDT1
  st x+,zero ; CANIDM4
  st x+,zero ; CANIDM3
  st x+,zero ; CANIDM2
  st x+,zero ; CANIDM1

  ; move to CANMSG
  adiw x,2

  ; clear data fifo
  st x,zero
  st x,zero
  st x,zero
  st x,zero
  st x,zero
  st x,zero
  st x,zero
  st x,zero
  ret


;; mobclrall
;;
;; ( -- )

link_
.db "mobclrall",0

mobclrall:
  ldi temp0,$e0

mobclrall_loop:
  out_ CANPAGE,temp0
  rcall mobclr
  subi temp0,$10
  brcc mobclrall_loop
  ret


;; mobget
;;
;; ( -- n ; f )

link_
.db "mobget",0,0

mobget:
  ldi temp0,$e0

mobget_loop:
  out_ CANPAGE,temp0
  in_ temp1,CANCDMOB
  andi temp1,(1<<CONMOB1)|(1<<CONMOB0)
  breq mobget_found

  subi temp0,$10
  brcc mobget_loop

mobget_notfound:
  false_
  ret

mobget_found:
  dup_
  mov tosl,temp0
  swap tosl
  clr tosh
  true_
  ret


;; to standard id format

tostd:
  lsl tosl
  rol tosh
  lsl tosl
  rol tosh
  lsl tosl
  rol tosh
  lsl tosl
  rol tosh
  lsl tosl
  rol tosh
  ret


;; from standard id format

fromstd:
  lsr tosh
  ror tosl
  lsr tosh
  ror tosl
  lsr tosh
  ror tosl
  lsr tosh
  ror tosl
  lsr tosh
  ror tosl
  ret


;; id!
;;
;; ( x -- )

link_
.db "id!",0

idstore:
  rcall tostd
  out_ CANIDT2,tosl
  out_ CANIDT1,tosh
;  cbi_ CANCDMOB,IDE,temp0
  out_ CANCDMOB,zero
  drop_
  ret


;; id@
;;
;; ( -- x )

link_
.db "id@",0

idfetch:
  dup_
  in_ tosl,CANIDT2
  in_ tosh,CANIDT1
  rjmp fromstd


;; mask!
;;
;; ( x -- )

link_
.db "mask!",0

maskstore:
  rcall tostd
  out_ CANIDM2,tosl
  out_ CANIDM1,tosh
  drop_
  ret


;; mask@
;;
;; ( -- x )

link_
.db "mask@",0

maskfetch:
  dup_
  in_ tosl,CANIDM2
  in_ tosh,CANIDM1
  rjmp fromstd


;; to extended id format

toext:
  ld xl,y+
  ld xh,y+
  lsl xl
  rol xh
  rol tosl
  rol tosh
  lsl xl
  rol xh
  rol tosl
  rol tosh
  lsl xl
  rol xh
  rol tosl
  rol tosh
  ret


;; from extended id format

fromext:
  lsr tosh
  ror tosl
  ror xh
  ror xl
  lsr tosh
  ror tosl
  ror xh
  ror xl
  lsr tosh
  ror tosl
  ror xh
  ror xl
  st -y,xh
  st -y,xl
  ret


;; xid!
;;
;; ( d -- )

link_
.db "xid!",0,0

xidstore:
  rcall toext
  out_ CANIDT4,xl
  out_ CANIDT3,xh
  out_ CANIDT2,tosl
  out_ CANIDT1,tosh
;  sbi_ CANCDMOB,IDE,temp0
  ldi temp0,(1<<IDE)
  out_ CANCDMOB,temp0
  drop_
  ret


;; xid@
;;
;; ( -- d )

link_
.db "xid@",0,0

xidfetch:
  dup_
  in_ xl,CANIDT4
  in_ xh,CANIDT3
  in_ tosl,CANIDT2
  in_ tosh,CANIDT1
  rjmp fromext


;; xmask!
;;
;; ( d -- )

link_
.db "xmask!",0,0

xmaskstore:
  rcall toext
  out_ CANIDM4,xl
  out_ CANIDM3,xh
  out_ CANIDM2,tosl
  out_ CANIDM1,tosh
  drop_
  ret


;; xmask@
;;
;; ( -- d )

link_
.db "xmask@",0,0

xmaskfetch:
  dup_
  in_ xl,CANIDM4
  in_ xh,CANIDM3
  in_ tosl,CANIDM2
  in_ tosh,CANIDM1
  rjmp fromext


;; dlc!
;;
;; ( n -- )

link_
.db "dlc!",0,0

dlcstore:
  in_ temp0,CANCDMOB
  andi temp0,$f0

  andi tosl,$0f
  or temp0,tosl
  out_ CANCDMOB,temp0

  drop_
  ret


;; dlc@
;;
;; ( -- n )

link_
.db "dlc@",0,0

dlcfetch:
  dup_
  in_ tosl,CANCDMOB
  andi tosl,$0f
  clr tosh
  ret


;; canc!
;;
;; ( c -- )

link_
.db "canc!",0

cancstore:
  out_ CANMSG,tosl
  drop_
  ret


;; can!
;;
;; ( x -- )

link_
.db "can!",0,0

canstore:
  out_ CANMSG,tosh
  out_ CANMSG,tosl
  drop_
  ret


;; canc@
;;
;; ( -- c )

link_
.db "canc@",0

cancfetch:
  dup_
  in_ tosl,CANMSG
  clr tosh
  ret


;; can@
;;
;; ( -- x )

link_
.db "can@",0,0

canfetch:
  dup_
  in_ tosh,CANMSG
  in_ tosl,CANMSG
  ret


;; moboff
;;
;; ( -- )

link_
.db "moboff",0,0

moboff:
  in_ temp0,CANCDMOB
  andi temp0,low(~((1<<CONMOB1)|(1<<CONMOB0)))
  out_ CANCDMOB,temp0
  ret


;; mobtx
;;
;; ( -- )

link_
.db "mobtx",0

mobtx:
  out_ CANSTMOB,zero
  in_ temp0,CANCDMOB
  ori temp0,(1<<CONMOB0)
  out_ CANCDMOB,temp0
  ret


;; mobrx
;;
;; ( -- )

link_
.db "mobrx",0

mobrx:
  out_ CANSTMOB,zero
  in_ temp0,CANCDMOB
  ori temp0,(1<<CONMOB1)
  out_ CANCDMOB,temp0
  ret


;; mobrxb
;;
;; ( -- )

link_
.db "mobrxb",0,0

mobrxb:
  out_ CANSTMOB,zero
  in_ temp0,CANCDMOB
  ori temp0,(1<<CONMOB1)|(1<<CONMOB0)
  out_ CANCDMOB,temp0
  ret


;; cantx?
;;
;; ( -- ; f )

link_
.db "cantx?",0,0

cantx:
  in_ temp0,CANSTMOB
  andi temp0,(1<<TXOK)
  ret


;; canrx?
;;
;; ( -- ; f )

link_
.db "canrx?",0,0

canrx:
  in_ temp0,CANSTMOB
  andi temp0,(1<<RXOK)
  ret


;; mobst
;;
;; ( -- )

link_
.db "mobst",0

mobst:
  out_ CANSTMOB,zero
  ret

.endif

