;;; spi


;; defines

; SPCR
.equ SPIE = 7
.equ SPE = 6
.equ DORD = 5
.equ MSTR = 4
.equ CPOL = 3
.equ CPHA = 2
.equ SPR1 = 1
.equ SPR0 = 0

; SPSR
.equ SPIF = 7
.equ WCOL = 6
.equ SPI2X = 0


;; spi
;;
;; ( -- )
;;
;; enable spi

link_
.db "spi",0

spi:
  ; configure i/o pins
  on_ SS
  on_ SCK
  on_ MOSI
  off_ MISO

  ; enable double speed mode
  ldi temp0,(1<<SPI2X)
  out_ SPSR,temp0

  ; enable master mode at clk/2, sample on falling edge
  ldi temp0,(1<<SPE)|(1<<MSTR)|(1<<CPOL)
  out_ SPCR,temp0
  ret


;; /spi
;;
;; ( -- )
;;
;; disable spi

link_
.db "/spi",0,0

notspi:
  out_ SPCR,zero
  ret


;; spix
;;
;; ( c1 -- c2 )
;;
;; transfer byte

link_
.db "spix",0,0

spix:
  ; start transmission
  out_ SPDR,tosl

spix_wait:
  ; wait until complete
  in_ temp0,SPSR
  andi temp0,(1<<SPIF)
  brne spix_done

  call pause
  rjmp spix_wait

;  sbis_ SPSR,SPIF,temp0
;  rjmp spix_wait

spix_done:
  ; get response
  in_ tosl,SPDR
  clr tosh
  ret


;; spitx
;;
;; ( c -- )
;;
;; send byte

link_
.db "spitx",0

spitx:
  rcall spix
  drop_
  ret


;; spirx
;;
;; ( -- c )
;;
;; receive byte

link_
.db "spirx",0

spirx:
  lit_ 0
  rjmp spix

