;;; access io registers

;; use io address instead of
;; memory mapped address if
;; possible

.macro in_
.if (@1 >= $20) && (@1 < $60)
  in @0,@1-$20
.else
  lds @0,@1
.endif
.endmacro

.macro out_
.if (@0 >= $20) && (@0 < $60)
  out @0-$20,@1
.else
  sts @0,@1
.endif
.endmacro

.macro sbic_
.if (@0 >= $20) && (@0 < $40)
  sbic @0-$20,@1
.else
  in_ @2,@0
  sbrc @2,@1
.endif
.endmacro

.macro sbis_
.if (@0 >= $20) && (@0 < $40)
  sbis @0-$20,@1
.else
  in_ @2,@0
  sbrs @2,@1
.endif
.endmacro

.macro sbi_
.if (@0 >= $20) && (@0 < $40)
  sbi @0-$20,@1
.else
  in_ @2,@0
  ori @2,exp2(@1)
  out_ @0,@2
.endif
.endmacro

.macro cbi_
.if (@0 >= $20) && (@0 < $40)
  cbi @0-$20,@1
.else
  in_ @2,@0
  andi @2,~(exp2(@1))
  out_ @0,@2
.endif
.endmacro


;; encode address and bit number in one variable

.macro bit_
  .equ @0 = (@1 << 8) | @2
.endmacro

.macro on_
  sbi_ (@0 >> 8),(@0 & $ff)
.endmacro

.macro off_
  sbi_ (@0 >> 8),(@0 & $ff)
.endmacro

